// ShockingImages
// by StimCum
// v0.1 first version
//
// Big Thanks to MissEshock2002 who inspired me with her fantastic work.

setInfos(9, "ShockingImages", "It could be e-shocking and painful to watch these images.", "StimCum", "started", 0xFFFFFF, "en", ["images", "formale", "forfemale", "estim", "pain"])

//definitions + configuration
def DefImagePath = "images/ShockingImages"
def DefSoundFilePath = "sounds/ShockingImages"
def Title = "<h1 style='font-size:140%;'>Shocking Images</h1>\n\n"
def MsgText = "Welcome to Your personal shocking images slide show.\n\nStick on your electrodes, relax and have shocking fun."
def startScript = loadString("intro.start_script")
Boolean IsSysStartScript = false
if(startScript=="ShockingImages") {IsSysStartScript=true}

def IntroImageFound = 0
if (new File(getDataFolder().replaceAll("\\\\", "/") + DefImagePath + "/GetShocked.png").exists()){
    setImage("ShockingImages/GetShocked.png")
    IntroImageFound = 1
}

if(!loadBoolean("toys.estim")) {
	show(Title+"The script doesn't work without an estim device. Come back when you're wired up.")
	showButton("OK")
	setImage(null)
	show(null)
	return startScript
}

List<String> ImageFileNames = []
def ImgPath = loadString("ShockingImages.ImgPath")
if(ImgPath==null){
    if(IntroImageFound==1){
        ImgPath = getDataFolder().replaceAll("\\\\", "/") + DefImagePath + "/"
    }
    else
    {
        ImgPath = System.getProperty("user.dir")
    }
}
def loadImageFiles = {
    new File(ImgPath).eachFileRecurse() {file->
        	if(file.isFile()&&file.getAbsolutePath().endsWith(".png")||file.getAbsolutePath().endsWith(".jpg")||file.getAbsolutePath().endsWith(".jpeg")||file.getAbsolutePath().endsWith(".gif"))   
        {ImageFileNames << file.getAbsolutePath()}
    }
}
def getRandomFileName = { return ImageFileNames[getRandom(ImageFileNames.size())] }

// Read estim variables
//if(loadString("ShockingImages.EstimStart")==null) {save("ShockingImages.EstimStart", "usbcontrol.exe start")} // the command you use to control your device needs to be in the scripts folder
//if(loadString("ShockingImages.EstimFinish")==null) {save("ShockingImages.EstimFinish", "usbcontrol.exe stop")}
//if(loadInteger("ShockingImages.EstimTime")==null) {save("ShockingImages.EstimTime", 500)} //in ms
//def EstimStart = loadString("ShockingImages.EstimStart")
//def EstimFinish = loadString("ShockingImages.EstimFinish")
//def EstimTime = loadInteger("ShockingImages.EstimTime")

if(loadBoolean("ShockingImages.EstimAudio")==null) {save("ShockingImages.EstimAudio", true)}
def EstimAudio = loadBoolean("ShockingImages.EstimAudio")
if(loadInteger("ShockingImages.MaxShocksPerCycle")==null) {save("ShockingImages.MaxShocksPerCycle", 5)}
def MaxShocksPerCycle = loadInteger("ShockingImages.MaxShocksPerCycle")
if(loadBoolean("ShockingImages.RandomShocksPerCycle")==null) {save("ShockingImages.RandomShocksPerCycle", true)}
def RandomShocksPerCycle = loadBoolean("ShockingImages.RandomShocksPerCycle")
if(loadBoolean("ShockingImages.RandomWaitTime")==null) {save("ShockingImages.RandomWaitTime", true)}
def RandomWaitTime = loadBoolean("ShockingImages.RandomWaitTime")

def DefSoundFile = ""
def stimFiles = []
if (new File(getDataFolder().replaceAll("\\\\", "/")+"sounds/courtroom/elec_chair.mp3").exists()){
    DefSoundFile = new File(getDataFolder().replaceAll("\\\\", "/")+"sounds/courtroom/elec_chair.mp3").getAbsolutePath()
    stimFiles << DefSoundFile
}
def stimPath = loadString("ShockingImages.EstimPath")

// initialization
if(!getBoolean(Title+"Hi, "+loadString("intro.name")+"\n\n"+MsgText+"\n\nYou can enjoy watching images as installed under: "+ImgPath+"\n\nBut be warned:\nIn order to see the next Image You have to endure several e-shocks that will be applied by playing soundfiles.\n\nContinue?"))
{
	setImage(null)
	show(null)
    return startScript
}

if(!getBoolean(Title+"Do You want to configure settings?","Skip", "Setup"))
{
    String sndText
    String cfgtxt    
    boolean bConf = true
    while (bConf) {  
        sndText=stimPath
        if(sndText==null){
            sndText="Not set.\n(Using: "+stimFiles+")"
        }    
        cfgtxt = Title+"<p style='font-family:monospace;font-size:12px;'>" +
                "Image path .......................... " + ImgPath + "\n" +
                "Use estim audio (play sound files)... " + EstimAudio + "\n" +
                "Sound file path ..................... " + sndText + "\n" +
                "Shocks per cycle .................... " + MaxShocksPerCycle + "\n" +
                "Random shocks per cycle (0-"+MaxShocksPerCycle+")........ " + RandomShocksPerCycle + "\n" +
                "Random wait time between ............ " + RandomWaitTime + "\n" +
                "(Note: You can only choose whether there is a random wait time between images and shocks.)\n" +            
                "Is set as start script .............. " + IsSysStartScript + "\n" +
        "</p>"        
        show(cfgtxt)    
        int menu = getSelectedValue(cfgtxt, [
                "Image path",
                "Sound file path",
                "Shocks per cycle",
                "Random shocks per cycle",
                "Random wait time",
                "Set as start script",
                "----------------",
                "Reset to default",
                "Save & Exit",
                "Exit"
        ])
        switch (menu) {
            case 0:
                if (ImgPath==null){
                    ImgPath = DefImagePath
                }
                ImgPath = getString("Image file path: (*.jpg, *.png, *.gif)?",ImgPath)
                break
            case 1:
                if (stimPath==null){
                    stimPath = DefSoundFilePath
                }
                stimPath = getString("Sound file path: (*.mp3, *.wav)?",stimPath)
                break
            case 2:
                MaxShocksPerCycle = getInteger("Shocks per cycle?",MaxShocksPerCycle)
                break
            case 3:
                //RandomShocksPerCycle = getString("Random shocks per cycle (0-"+MaxShocksPerCycle+")?",RandomShocksPerCycle)
                RandomShocksPerCycle = getBoolean("Random shocks per cycle (0-"+MaxShocksPerCycle+")?")                            
                break
            case 4:
                //RandomWaitTime = getString("Random wait time?",RandomWaitTime)
                RandomWaitTime = getBoolean("Random wait time?")                
                break
            case 5:
                //IsSysStartScript = getString("Set as start script?",IsSysStartScript)
                IsSysStartScript = getBoolean("Set as start script?")                
                break
        // no case 6 ----------------
            case 7:
                //resetDefault()
                ImgPath = DefImagePath
                stimPath = DefSoundFilePath
                MaxShocksPerCycle = 5
                RandomShocksPerCycle = true
                RandomWaitTime = true
                IsSysStartScript = false
                break
            case 8: // Save & Exit
                save("ShockingImages.ImgPath",ImgPath)            
                save("ShockingImages.EstimPath",stimPath)
                save("ShockingImages.MaxShocksPerCycle",MaxShocksPerCycle)
                save("ShockingImages.RandomShocksPerCycle",RandomShocksPerCycle)                
                save("ShockingImages.RandomWaitTime",RandomWaitTime)                
                
                if(IsSysStartScript)
                {
                    save("intro.start_script", "ShockingImages")                
                }
                else
                {
                    if(loadString("intro.start_script") == "ShockingImages")
                    {
                        save("intro.start_script", null)
                    }                   
                }                
                bConf = false
                break
            case 9: // Exit
                bConf = false
                break
        }
    }    

	//showButton("OK")
}

show(Title+MsgText+"\n\nLoading image file names. Please, wait.")

loadImageFiles()

if(ImageFileNames.size<1) {
	show(Title+"Error! Cannot find image files.")
	showButton("OK")
	show(null)
	setImage(null)
	return startScript
}

show(Title+MsgText+"\n\nLoading sound file names. Please, wait.")

if (stimPath!=null){
    new File(stimPath).eachFileRecurse() {file->
        if(file.isFile()&&file.getAbsolutePath().endsWith(".mp3")||file.getAbsolutePath().endsWith(".wav")) 
            {stimFiles << file.getAbsolutePath()}
    }
}

if(stimFiles.size<1) {
	show(Title+"Error! Cannot find sound files in " + DefSoundFilePath + "\n\nYou cannot use audio estim!")
	showButton("OK")
	show(null)
	setImage(null)
	return startScript
}

show(Title+"Welcome to ShockingImages.\n\nStick on your electrodes, relax and have shocking fun.\n\nReady.")

//Start ######################################################################################################

//showButton("OK")                   	           
show(null)

def bLoop = true
if(EstimAudio){
    while(bLoop){
			if(getBoolean(Title+"You should test Your device is working \nand set to a very high output level.\n\nDon't continue until you're sure your device is working as desired.", "Continue!", "Test?")) {
                bLoop = false				
			}
			else 
			{
				playBackgroundSound("courtroom/elec_chair.mp3")
				wait(1)
				playBackgroundSound(null)
			}
    }
}
else
{
    return startScript
}
		
def totalImages = ImageFileNames.size()
def totalImagesShown = 0
def totalShocksApplied = 0
def sTime = 10
def totalcnt = MaxShocksPerCycle

while(true) {
	setImage(getRandomFileName())
    totalImagesShown++	
    show("Total images found: "+totalImages+"\nImages shown: "+totalImagesShown+"\nShocks applied: "+totalShocksApplied+"\n\nAre You ready?")	            	
    
    if(RandomWaitTime){wait(getRandom(2000)/100+0.1)}
	
	if (RandomShocksPerCycle){
        totalcnt = getRandom(MaxShocksPerCycle)
    }
    else
    {
        totalcnt = MaxShocksPerCycle
    }
    for(def i=0; i<totalcnt; i++) {
        if(EstimAudio) {
            totalShocksApplied++
            sTime = getRandom(15)+getRandom(10)+getRandom(5)            
            show("Total images found: "+totalImages+"\nImages shown: "+totalImagesShown+"\nShocks applied: "+totalShocksApplied+"\n\nEnjoy!\n"+(i+1)+"/"+totalcnt + " (" + sTime + "s)")
            
            playBackgroundSound(stimFiles[getRandom(stimFiles.size)],10)
            waitWithGauge(sTime)	
            playBackgroundSound(null)
            }	 

        if(RandomWaitTime){wait(getRandom(1000)/100+0.1)}            
	}
	
    if ((3) != showButton("STOP", (3))) {
        if(!getBoolean("Do You really want to stop?","No","Yes"))
        {
            show("Total images found: "+totalImages+"\nImages shown: "+totalImagesShown+"\nShocks applied: "+totalShocksApplied+"\n\nBye, bye!")	        
            return startScript
        }
        else
        {
            def bStay = true
            while(bStay)
            {
                totalShocksApplied++
                playBackgroundSound(null)
                playBackgroundSound(stimFiles[getRandom(stimFiles.size)],100)
                if(!getBoolean("Total images found: "+totalImages+"\nImages shown: "+totalImagesShown+"\nShocks applied: "+totalShocksApplied+"\n\nEnjoy!\n\n\nDo You want to keep watching this and stay getting shocked?","Yes, next shock please!","No"))
                {
                    playBackgroundSound(null)
                    if(!getBoolean("Do You want to","continue?","or re-start the Script?"))
                    {
                        return "ShockingImages"
                    }
                    else
                    {
                        bStay = false
                    }
                }
            }            
        }        
    }	
}

setImage(null);
show("");
return startScript
//exit()

// This script, from http://ss.deviatenow.com, is protected by this licence :
// CC BY-SA 4.0, see http://creativecommons.org/licenses/by-sa/4.0/
/*
 * Resources
 * scripts/ShockingImages.groovy
 * images/ShockingImages/*.jpg
 * images/ShockingImages/*.png
 * images/ShockingImages/*.gif 
 * sounds/ShockingImages/*.mp3
 * sounds/ShockingImages/*.wav
 * sounds/courtroom/elec_chair.mp3
 */
